-- EnvenomX Core.lua by break19
-- The following if/then statement disables the addon, and exits early, preventing it from loading,
-- But only if the character is not a rogue.
if (select(2, UnitClass("player"))) ~= "ROGUE" then
	DisableAddOn("EnvenomX")
	return
end

local _G = getfenv(0)
local vx = LibStub("AceAddon-3.0"):NewAddon("EnvenomX", "AceEvent-3.0", "AceBucket-3.0", "AceTimer-3.0", "AceConsole-3.0","LibSink-2.0")
local L = LibStub("AceLocale-3.0"):GetLocale("EnvenomX", true)
local dialog = LibStub("AceConfigDialog-3.0")
local spellname = L["Deadly Poison"]
local options = {}
local scroll = 0

local bucketlist = {
	"PLAYER_COMBO_POINTS",
	"UNIT_AURA",
	"PLAYER_TARGET_CHANGED"
}

options = {
	type = "group",
	args = {
		Text = {
			order = 1,
			type = "input",
			name = L["Output Text"],
			desc = L["What to say when EnvenomX fires (default: Envenom!!)"],
			set = function(k,v) vx.db.profile.text = v; end,
		},
	}
}

function vx:OnInitialize()
	vx.db = LibStub("AceDB-3.0"):New("EnvenomXDB")
	vx.db:RegisterDefaults({
		profile = {
			r = 1,
			g = 1,
			b = 0,
			font = "GameFontNormal",
			size = 26,
			outline = "ThickOutline",
			text = L["Envenom!!"],
			stickytext = 1,
			icon = "\\Interface\\Icons\\Trade_BrewPoison",
			loc = {}
		}
	})
	self:SetSinkStorage(self.db.profile.loc)
	options.args.output = self:GetSinkAce3OptionsDataTable()
	LibStub("AceConfig-3.0"):RegisterOptionsTable("EnvenomX", options)
	self:RegisterChatCommand("envenomx", function() dialog:Open("EnvenomX") end)
	self:RegisterChatCommand("evx", function() dialog:Open("EnvenomX") end)
end

function vx:OnEnable()
	self:RegisterEvent("PLAYER_REGEN_DISABLED","CombatEnter")
	self:RegisterEvent("PLAYER_REGEN_ENABLED","CombatLeave")
end

function vx:onDisable()
	self:UnregisterEvent("PLAYER_REGEN_DISABLED")
	self:UnregisterEvent("PLAYER_REGEN_ENABLED")
end

function vx:CombatEnter()
	self:RegisterBucketEvent(bucketlist, 2.0, "CheckEnvenom")
end

function vx:CombatLeave()
	self:UnregisterBucket("CheckEnvenom")
end

function vx:CountPoisons()
	for index=1,40,1 do
		local name, rank, texture, count, debuffType, duration, timeLeft  =  UnitDebuff("target", index)
		if not name then break end
		if duration and string.find( name, spellname ) then
			return count
		end
	end
	return 0
end	

function vx:CheckEnvenom()
	local cp = _G.GetComboPoints()
	local dp = vx:CountPoisons()
	if cp==5 and dp==5 then
		vx:DoScroll()
	end
end

function vx:DoScroll()
	scroll = scroll + 1
	if scroll == 1 then
		self:Pour(vx.db.profile.text, vx.db.profile.r, vx.db.profile.g, vx.db.profile.b, vx.db.profile.font, vx.db.profile.size, vx.db.profile.outline, vx.db.profile.stickytext, vx.db.profile.loc, vx.db.profile.icon)		
	end
	vxtimer = vx:ScheduleTimer(function() scroll = 0 end,5)
end

function vx:ResetScroll()
	scroll = 0
end